# ---------------------------------------------------------------------------
# - APX0005.als                                                             -
# - afnix:apx test module                                                   -
# ---------------------------------------------------------------------------
# - This program is free software;  you can redistribute it  and/or  modify -
# - it provided that this copyright notice is kept intact.                  -
# -                                                                         -
# - This program  is  distributed in  the hope  that it will be useful, but -
# - without  any  warranty;  without  even   the   implied    warranty   of -
# - merchantability or fitness for a particular purpose.  In no event shall -
# - the copyright holder be liable for any  direct, indirect, incidental or -
# - special damages arising in any way out of the use of this software.     -
# ---------------------------------------------------------------------------
# - copyright (c) 1999-2007 amaury darsch                                   -
# ---------------------------------------------------------------------------

# @info   root node generator test module
# @author amaury darsch

# load the project
interp:load "apx-prjld"

# create a root node
const root (afnix:apx:root)
# check node size (decl + apx)
assert 2   (root:child-length)

# add a new request
const rqst (root:add-request-command "help")
# check the node name
assert "apx:request" (rqst:get-name)
# check the command value
assert "help" (rqst:get-command-value)

# get the request node list
trans  rlst (root:get-request-list)
assert 1    (rlst:length)

# add a new reply
const rply (root:add-reply-status "0")
# check the node name
assert "apx:reply" (rply:get-name)
# check the status code
assert "0" (rply:get-status)

# get the reply node list
trans  rlst (root:get-reply-list)
assert 1    (rlst:length)

